GeneratedMessageV3.ExtendableMessage
Date: 2017-07-08

com.google.protobuf

## Class GeneratedMessageV3.ExtendableMessage<MessageType extends GeneratedMessageV3.ExtendableMessage>

- java.lang.Object
- - com.google.protobuf.AbstractMessageLite
  - - com.google.protobuf.AbstractMessage
    - - com.google.protobuf.GeneratedMessageV3
      - - com.google.protobuf.GeneratedMessageV3.ExtendableMessage<MessageType>

- All Implemented Interfaces:
    GeneratedMessageV3.ExtendableMessageOrBuilder<MessageType>, Message, MessageLite, MessageLiteOrBuilder, MessageOrBuilder, java.io.Serializable
  Direct Known Subclasses:
    DescriptorProtos.EnumOptions, DescriptorProtos.EnumValueOptions, DescriptorProtos.FieldOptions, DescriptorProtos.FileOptions, DescriptorProtos.MessageOptions, DescriptorProtos.MethodOptions, DescriptorProtos.OneofOptions, DescriptorProtos.ServiceOptions
  Enclosing class:
    GeneratedMessageV3

      public abstract static class GeneratedMessageV3.ExtendableMessage<MessageType extends GeneratedMessageV3.ExtendableMessage>
      extends GeneratedMessageV3
      implements GeneratedMessageV3.ExtendableMessageOrBuilder<MessageType>

  Generated message classes for message types that contain extension ranges subclass this.

  This class implements type-safe accessors for extensions. They implement all the same operations that you can do with normal fields -- e.g. "has", "get", and "getCount" -- but for extensions. The extensions are identified using instances of the class `GeneratedMessage.GeneratedExtension`; the protocol compiler generates a static instance of this class for every extension in its input. Through the magic of generics, all is made type-safe.

  For example, imagine you have the `.proto` file:

       option java_class = "MyProto";

       message Foo {
         extensions 1000 to max;
       }

       extend Foo {
         optional int32 bar;
       }

  Then you might write code like:

       MyProto.Foo foo = getFoo();
       int i = foo.getExtension(MyProto.bar);

  See also `GeneratedMessageV3.ExtendableBuilder`.

  See Also:
    Serialized Form

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Class and Description
    --- | ---
    `protected class` | `GeneratedMessageV3.ExtendableMessage.ExtensionWriter` Used by subclasses to serialize extensions.

    - ### Nested classes/interfaces inherited from class com.google.protobuf.GeneratedMessageV3

      `GeneratedMessageV3.Builder<BuilderType extends GeneratedMessageV3.Builder<BuilderType>>, GeneratedMessageV3.BuilderParent, GeneratedMessageV3.ExtendableBuilder<MessageType extends GeneratedMessageV3.ExtendableMessage,BuilderType extends GeneratedMessageV3.ExtendableBuilder<MessageType,BuilderType>>, GeneratedMessageV3.ExtendableMessage<MessageType extends GeneratedMessageV3.ExtendableMessage>, GeneratedMessageV3.ExtendableMessageOrBuilder<MessageType extends GeneratedMessageV3.ExtendableMessage>, GeneratedMessageV3.FieldAccessorTable`

  - ### Field Summary

    - ### Fields inherited from class com.google.protobuf.GeneratedMessageV3

      `alwaysUseFieldBuilders, unknownFields`

    - ### Fields inherited from class com.google.protobuf.AbstractMessage

      `memoizedSize`

    - ### Fields inherited from class com.google.protobuf.AbstractMessageLite

      `memoizedHashCode`

  - ### Constructor Summary

    Constructors
    Modifier | Constructor and Description
    --- | ---
    `protected` | `GeneratedMessageV3.ExtendableMessage()`
    `protected` | `GeneratedMessageV3.ExtendableMessage(GeneratedMessageV3.ExtendableBuilder<MessageType,?> builder)`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `protected boolean` | `extensionsAreInitialized()` Called by subclasses to check if all extensions are initialized.
    `protected int` | `extensionsSerializedSize()` Called by subclasses to compute the size of extensions.
    `protected int` | `extensionsSerializedSizeAsMessageSet()`
    `java.util.Map<Descriptors.FieldDescriptor,java.lang.Object>` | `getAllFields()` Returns a collection of all the fields in this message which are set and their corresponding values.
    `java.util.Map<Descriptors.FieldDescriptor,java.lang.Object>` | `getAllFieldsRaw()` Returns a collection of all the fields in this message which are set and their corresponding values.
    `<Type> Type` | `getExtension(Extension<MessageType,java.util.List<Type>> extension, int index)` Get one element of a repeated extension.
    `<Type> Type` | `getExtension(Extension<MessageType,Type> extension)` Get the value of an extension.
    `<Type> Type` | `getExtension(ExtensionLite<MessageType,java.util.List<Type>> extensionLite, int index)` Get one element of a repeated extension.
    `<Type> Type` | `getExtension(ExtensionLite<MessageType,Type> extensionLite)` Get the value of an extension.
    `<Type> Type` | `getExtension(GeneratedMessage.GeneratedExtension<MessageType,java.util.List<Type>> extension, int index)` Get one element of a repeated extension.
    `<Type> Type` | `getExtension(GeneratedMessage.GeneratedExtension<MessageType,Type> extension)` Get the value of an extension.
    `<Type> int` | `getExtensionCount(Extension<MessageType,java.util.List<Type>> extension)` Get the number of elements in a repeated extension.
    `<Type> int` | `getExtensionCount(ExtensionLite<MessageType,java.util.List<Type>> extensionLite)` Get the number of elements in a repeated extension.
    `<Type> int` | `getExtensionCount(GeneratedMessage.GeneratedExtension<MessageType,java.util.List<Type>> extension)` Get the number of elements in a repeated extension.
    `protected java.util.Map<Descriptors.FieldDescriptor,java.lang.Object>` | `getExtensionFields()`
    `java.lang.Object` | `getField(Descriptors.FieldDescriptor field)` Obtains the value of the given field, or the default value if it is not set.
    `java.lang.Object` | `getRepeatedField(Descriptors.FieldDescriptor field, int index)` Gets an element of a repeated field.
    `int` | `getRepeatedFieldCount(Descriptors.FieldDescriptor field)` Gets the number of elements of a repeated field.
    `<Type> boolean` | `hasExtension(Extension<MessageType,Type> extension)` Check if a singular extension is present.
    `<Type> boolean` | `hasExtension(ExtensionLite<MessageType,Type> extensionLite)` Check if a singular extension is present.
    `<Type> boolean` | `hasExtension(GeneratedMessage.GeneratedExtension<MessageType,Type> extension)` Check if a singular extension is present.
    `boolean` | `hasField(Descriptors.FieldDescriptor field)` Returns true if the given field is set.
    `boolean` | `isInitialized()` Returns true if all required fields in the message and all embedded messages are set, false otherwise.
    `protected void` | `makeExtensionsImmutable()` Used by parsing constructors in generated classes.
    `protected GeneratedMessageV3.ExtendableMessage.ExtensionWriter` | `newExtensionWriter()`
    `protected GeneratedMessageV3.ExtendableMessage.ExtensionWriter` | `newMessageSetExtensionWriter()`
    `protected boolean` | `parseUnknownField(CodedInputStream input, UnknownFieldSet.Builder unknownFields, ExtensionRegistryLite extensionRegistry, int tag)` Called by subclasses to parse an unknown field.

    - ### Methods inherited from class com.google.protobuf.GeneratedMessageV3

      `computeStringSize, computeStringSizeNoTag, getDescriptorForType, getOneofFieldDescriptor, getParserForType, getSerializedSize, getUnknownFields, hasOneof, internalGetFieldAccessorTable, internalGetMapField, newBuilderForType, newBuilderForType, parseDelimitedWithIOException, parseDelimitedWithIOException, parseWithIOException, parseWithIOException, parseWithIOException, parseWithIOException, serializeBooleanMapTo, serializeIntegerMapTo, serializeLongMapTo, serializeStringMapTo, writeReplace, writeString, writeStringNoTag, writeTo`

    - ### Methods inherited from class com.google.protobuf.AbstractMessage

      `equals, findInitializationErrors, getInitializationErrorString, hashBoolean, hashCode, hashEnum, hashEnumList, hashFields, hashLong, toString`

    - ### Methods inherited from class com.google.protobuf.AbstractMessageLite

      `addAll, checkByteStringIsUtf8, toByteArray, toByteString, writeDelimitedTo, writeTo`

    - ### Methods inherited from class java.lang.Object

      `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface com.google.protobuf.GeneratedMessageV3.ExtendableMessageOrBuilder

      `getDefaultInstanceForType`

    - ### Methods inherited from interface com.google.protobuf.MessageOrBuilder

      `findInitializationErrors, getDescriptorForType, getInitializationErrorString, getOneofFieldDescriptor, getUnknownFields, hasOneof`

    - ### Methods inherited from interface com.google.protobuf.Message

      `newBuilderForType, toBuilder`

    - ### Methods inherited from interface com.google.protobuf.MessageLite

      `toByteArray, toByteString, writeDelimitedTo, writeTo`

- - ### Constructor Detail

    - #### GeneratedMessageV3.ExtendableMessage

          protected GeneratedMessageV3.ExtendableMessage()

    - #### GeneratedMessageV3.ExtendableMessage

          protected GeneratedMessageV3.ExtendableMessage(GeneratedMessageV3.ExtendableBuilder<MessageType,?> builder)

  - ### Method Detail

    - #### hasExtension

          public final <Type> boolean hasExtension(ExtensionLite<MessageType,Type> extensionLite)

      Check if a singular extension is present.
      Specified by:
        `hasExtension` in interface `GeneratedMessageV3.ExtendableMessageOrBuilder<MessageType extends GeneratedMessageV3.ExtendableMessage>`

    - #### getExtensionCount

          public final <Type> int getExtensionCount(ExtensionLite<MessageType,java.util.List<Type>> extensionLite)

      Get the number of elements in a repeated extension.
      Specified by:
        `getExtensionCount` in interface `GeneratedMessageV3.ExtendableMessageOrBuilder<MessageType extends GeneratedMessageV3.ExtendableMessage>`

    - #### getExtension

          public final <Type> Type getExtension(ExtensionLite<MessageType,Type> extensionLite)

      Get the value of an extension.
      Specified by:
        `getExtension` in interface `GeneratedMessageV3.ExtendableMessageOrBuilder<MessageType extends GeneratedMessageV3.ExtendableMessage>`

    - #### getExtension

          public final <Type> Type getExtension(ExtensionLite<MessageType,java.util.List<Type>> extensionLite,
                                 int index)

      Get one element of a repeated extension.
      Specified by:
        `getExtension` in interface `GeneratedMessageV3.ExtendableMessageOrBuilder<MessageType extends GeneratedMessageV3.ExtendableMessage>`

    - #### hasExtension

          public final <Type> boolean hasExtension(Extension<MessageType,Type> extension)

      Check if a singular extension is present.
      Specified by:
        `hasExtension` in interface `GeneratedMessageV3.ExtendableMessageOrBuilder<MessageType extends GeneratedMessageV3.ExtendableMessage>`

    - #### hasExtension

          public final <Type> boolean hasExtension(GeneratedMessage.GeneratedExtension<MessageType,Type> extension)

      Check if a singular extension is present.
      Specified by:
        `hasExtension` in interface `GeneratedMessageV3.ExtendableMessageOrBuilder<MessageType extends GeneratedMessageV3.ExtendableMessage>`

    - #### getExtensionCount

          public final <Type> int getExtensionCount(Extension<MessageType,java.util.List<Type>> extension)

      Get the number of elements in a repeated extension.
      Specified by:
        `getExtensionCount` in interface `GeneratedMessageV3.ExtendableMessageOrBuilder<MessageType extends GeneratedMessageV3.ExtendableMessage>`

    - #### getExtensionCount

          public final <Type> int getExtensionCount(GeneratedMessage.GeneratedExtension<MessageType,java.util.List<Type>> extension)

      Get the number of elements in a repeated extension.
      Specified by:
        `getExtensionCount` in interface `GeneratedMessageV3.ExtendableMessageOrBuilder<MessageType extends GeneratedMessageV3.ExtendableMessage>`

    - #### getExtension

          public final <Type> Type getExtension(Extension<MessageType,Type> extension)

      Get the value of an extension.
      Specified by:
        `getExtension` in interface `GeneratedMessageV3.ExtendableMessageOrBuilder<MessageType extends GeneratedMessageV3.ExtendableMessage>`

    - #### getExtension

          public final <Type> Type getExtension(GeneratedMessage.GeneratedExtension<MessageType,Type> extension)

      Get the value of an extension.
      Specified by:
        `getExtension` in interface `GeneratedMessageV3.ExtendableMessageOrBuilder<MessageType extends GeneratedMessageV3.ExtendableMessage>`

    - #### getExtension

          public final <Type> Type getExtension(Extension<MessageType,java.util.List<Type>> extension,
                                 int index)

      Get one element of a repeated extension.
      Specified by:
        `getExtension` in interface `GeneratedMessageV3.ExtendableMessageOrBuilder<MessageType extends GeneratedMessageV3.ExtendableMessage>`

    - #### getExtension

          public final <Type> Type getExtension(GeneratedMessage.GeneratedExtension<MessageType,java.util.List<Type>> extension,
                                 int index)

      Get one element of a repeated extension.
      Specified by:
        `getExtension` in interface `GeneratedMessageV3.ExtendableMessageOrBuilder<MessageType extends GeneratedMessageV3.ExtendableMessage>`

    - #### extensionsAreInitialized

          protected boolean extensionsAreInitialized()

      Called by subclasses to check if all extensions are initialized.

    - #### isInitialized

          public boolean isInitialized()

      Description copied from interface: `MessageLiteOrBuilder`
      Returns true if all required fields in the message and all embedded messages are set, false otherwise.

      See also: `MessageOrBuilder.getInitializationErrorString()`

      Specified by:
        `isInitialized` in interface `MessageLiteOrBuilder`
      Overrides:
        `isInitialized` in class `GeneratedMessageV3`

    - #### parseUnknownField

          protected boolean parseUnknownField(CodedInputStream input,
                                  UnknownFieldSet.Builder unknownFields,
                                  ExtensionRegistryLite extensionRegistry,
                                  int tag)
                                       throws java.io.IOException

      Description copied from class: `GeneratedMessageV3`
      Called by subclasses to parse an unknown field.
      Overrides:
        `parseUnknownField` in class `GeneratedMessageV3`
      Returns:
        `true` unless the tag is an end-group tag.
      Throws:
        `java.io.IOException`

    - #### makeExtensionsImmutable

          protected void makeExtensionsImmutable()

      Used by parsing constructors in generated classes.
      Overrides:
        `makeExtensionsImmutable` in class `GeneratedMessageV3`

    - #### newExtensionWriter

          protected GeneratedMessageV3.ExtendableMessage.ExtensionWriter newExtensionWriter()

    - #### newMessageSetExtensionWriter

          protected GeneratedMessageV3.ExtendableMessage.ExtensionWriter newMessageSetExtensionWriter()

    - #### extensionsSerializedSize

          protected int extensionsSerializedSize()

      Called by subclasses to compute the size of extensions.

    - #### extensionsSerializedSizeAsMessageSet

          protected int extensionsSerializedSizeAsMessageSet()

    - #### getExtensionFields

          protected java.util.Map<Descriptors.FieldDescriptor,java.lang.Object> getExtensionFields()

    - #### getAllFields

          public java.util.Map<Descriptors.FieldDescriptor,java.lang.Object> getAllFields()

      Description copied from interface: `MessageOrBuilder`
      Returns a collection of all the fields in this message which are set and their corresponding values. A singular ("required" or "optional") field is set iff hasField() returns true for that field. A "repeated" field is set iff getRepeatedFieldCount() is greater than zero. The values are exactly what would be returned by calling `MessageOrBuilder.getField(Descriptors.FieldDescriptor)` for each field. The map is guaranteed to be a sorted map, so iterating over it will return fields in order by field number.
      If this is for a builder, the returned map may or may not reflect future changes to the builder. Either way, the returned map is itself unmodifiable.
      Specified by:
        `getAllFields` in interface `MessageOrBuilder`
      Overrides:
        `getAllFields` in class `GeneratedMessageV3`

    - #### getAllFieldsRaw

          public java.util.Map<Descriptors.FieldDescriptor,java.lang.Object> getAllFieldsRaw()

      Description copied from class: `GeneratedMessageV3`
      Returns a collection of all the fields in this message which are set and their corresponding values. A singular ("required" or "optional") field is set iff hasField() returns true for that field. A "repeated" field is set iff getRepeatedFieldCount() is greater than zero. The values are exactly what would be returned by calling `GeneratedMessageV3.getFieldRaw(Descriptors.FieldDescriptor)` for each field. The map is guaranteed to be a sorted map, so iterating over it will return fields in order by field number.

    - #### hasField

          public boolean hasField(Descriptors.FieldDescriptor field)

      Description copied from interface: `MessageOrBuilder`
      Returns true if the given field is set. This is exactly equivalent to calling the generated "has" accessor method corresponding to the field.
      Specified by:
        `hasField` in interface `MessageOrBuilder`
      Overrides:
        `hasField` in class `GeneratedMessageV3`

    - #### getField

          public java.lang.Object getField(Descriptors.FieldDescriptor field)

      Description copied from interface: `MessageOrBuilder`
      Obtains the value of the given field, or the default value if it is not set. For primitive fields, the boxed primitive value is returned. For enum fields, the EnumValueDescriptor for the value is returned. For embedded message fields, the sub-message is returned. For repeated fields, a java.util.List is returned.
      Specified by:
        `getField` in interface `MessageOrBuilder`
      Overrides:
        `getField` in class `GeneratedMessageV3`

    - #### getRepeatedFieldCount

          public int getRepeatedFieldCount(Descriptors.FieldDescriptor field)

      Description copied from interface: `MessageOrBuilder`
      Gets the number of elements of a repeated field. This is exactly equivalent to calling the generated "Count" accessor method corresponding to the field.
      Specified by:
        `getRepeatedFieldCount` in interface `MessageOrBuilder`
      Overrides:
        `getRepeatedFieldCount` in class `GeneratedMessageV3`

    - #### getRepeatedField

          public java.lang.Object getRepeatedField(Descriptors.FieldDescriptor field,
                                          int index)

      Description copied from interface: `MessageOrBuilder`
      Gets an element of a repeated field. For primitive fields, the boxed primitive value is returned. For enum fields, the EnumValueDescriptor for the value is returned. For embedded message fields, the sub-message is returned.
      Specified by:
        `getRepeatedField` in interface `MessageOrBuilder`
      Overrides:
        `getRepeatedField` in class `GeneratedMessageV3`